## ia32-libs 20090808ubuntu9

=== elf/Makefile ===
# Copyright (C) 1995-2007,2008,2009,2010 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

# Makefile for elf subdirectory of GNU C Library.

subdir		:= elf

headers		= elf.h bits/elfclass.h link.h bits/link.h
routines	= $(dl-routines) dl-support dl-iteratephdr \
		  dl-addr enbl-secure dl-profstub \
		  dl-origin dl-libc dl-sym dl-tsd dl-sysdep

# The core dynamic linking functions are in libc for the static and
# profiled libraries.
dl-routines	= $(addprefix dl-,load cache lookup object reloc deps \
			          runtime error init fini debug misc \
				  version profile conflict tls origin scope \
				  execstack caller open close trampoline)
all-dl-routines = $(dl-routines) $(sysdep-dl-routines)
# But they are absent from the shared libc, because that code is in ld.so.
elide-routines.os = $(all-dl-routines) dl-support enbl-secure dl-origin \
		    dl-sysdep
shared-only-routines += dl-caller

# ld.so uses those routines, plus some special stuff for being the program
# interpreter and operating independent of libc.
rtld-routines	:= rtld $(dl-routines) dl-sysdep dl-environ dl-minimal
all-rtld-routines = $(rtld-routines) $(sysdep-rtld-routines)

distribute	:= rtld-Rules \
		   $(rtld-routines:=.c) dynamic-link.h do-rel.h dl-machine.h \
		   dl-cache.h dl-hash.h soinit.c sofini.c ldd.bash.in \
		   genrtldtbl.awk atomicity.h dl-procinfo.h ldsodefs.h \
		   dl-librecon.h interp.c sln.c dl-dst.h hp-timing.h \
		   dl-lookupcfg.h sprof.c gen-trusted-dirs.awk \
		   testobj1.c testobj2.c testobj3.c testobj4.c testobj5.c \
		   testobj6.c testobj1_1.c failobj.c unloadmod.c \
		   ldconfig.h ldconfig.c cache.c readlib.c readelflib.c \
		   chroot_canon.c gccframe.h \
		   dep1.c dep2.c dep3.c dep4.c dl-dtprocnum.h unsecvars.h \
		   vismain.c vismod1.c vismod2.c vismod3.c \
		   constload2.c constload3.c filtmod1.c filtmod2.c \
		   nodlopenmod.c nodelete.c nodelmod1.c nodelmod2.c \
		   nodelmod3.c nodelmod4.c nodlopen.c dl-osinfo.h \
		   reldepmod1.c reldepmod2.c reldepmod3.c reldepmod4.c \
		   reldepmod5.c reldepmod6.c \
		   reldep4mod1.c reldep4mod2.c reldep4mod3.c reldep4mod4.c \
		   nextmod1.c nextmod2.c pathoptobj.c tst-pathopt.sh \
		   neededobj1.c neededobj2.c neededobj3.c neededobj4.c \
		   neededobj5.c neededobj6.c firstobj.c \
		   unload2mod.c unload2dep.c ltglobmod1.c ltglobmod2.c \
		   testobj.h vismod.h globalmod1.c \
		   dblloadmod1.c dblloadmod2.c dblloadmod3.c \
		   reldep6mod4.c reldep6mod3.c reldep6mod2.c reldep6mod1.c \
		   reldep6mod0.c reldep7mod1.c reldep7mod2.c \
		   unwind-dw2.c unwind-dw2-fde.c unwind.h unwind-pe.h \
		   unwind-dw2-fde.h dwarf2.h dl-procinfo.c tls.h dl-tls.h \
		   tst-tlsmod1.c tst-tlsmod2.c tst-tlsmod3.c tst-tlsmod4.c \
		   tst-tlsmod5.c tst-tlsmod6.c tst-tlsmod7.c tst-tlsmod8.c \
		   tst-tlsmod9.c tst-tlsmod10.c tst-tlsmod11.c \
		   tst-tlsmod12.c tst-tls10.h tst-alignmod.c tst-alignmod2.c \
		   circlemod1.c circlemod1a.c circlemod2.c circlemod2a.c \
		   circlemod3.c circlemod3a.c nodlopenmod2.c \
		   tls-macros.h \
		   reldep8mod1.c reldep8mod2.c reldep8mod3.c \
		   nodel2mod1.c nodel2mod2.c nodel2mod3.c \
		   reldep9.c reldep9mod1.c reldep9mod2.c reldep9mod3.c \
		   tst-array1.exp tst-array2.exp tst-array4.exp \
		   tst-array2dep.c tst-piemod1.c \
		   tst-execstack-mod.c tst-dlmodcount.c \
		   check-textrel.c dl-sysdep.h test-dlopenrpathmod.c \
		   tst-deep1mod1.c tst-deep1mod2.c tst-deep1mod3.c \
		   unload3mod1.c unload3mod2.c unload3mod3.c unload3mod4.c \
		   unload4mod1.c unload4mod2.c unload4mod3.c unload4mod4.c \
		   unload6mod1.c unload6mod2.c unload6mod3.c \
		   unload7mod1.c unload7mod2.c \
		   tst-audit1.c tst-audit2.c tst-audit3.c tst-audit4.c \
		   tst-auditmod1.c tst-auditmod3a.c tst-auditmod3b.c \
		   tst-auditmod4a.c tst-auditmod4b.c \
		   tst-audit5.c tst-auditmod5a.c tst-auditmod5b.c \
		   tst-audit6.c tst-auditmod6a.c tst-auditmod6b.c \
		   tst-auditmod6c.c \
		   tst-audit7.c tst-auditmod7a.c tst-auditmod7b.c \
		   order2mod1.c order2mod2.c order2mod3.c order2mod4.c \
		   tst-stackguard1.c tst-stackguard1-static.c \
		   tst-array5.c tst-array5-static.c tst-array5dep.c \
		   tst-array5.exp tst-leaks1.c check-execstack.c \
		   ifuncmain1.c ifuncmain1pic.c ifuncmain1vis.c \
		   ifuncmain1vispic.c ifuncmain1static.c \
		   ifuncmain1staticpic.c ifuncmain1picstatic.c \
		   ifuncdep1.c ifuncdep1pic.c ifuncmod1.c \
		   ifuncmain1pie.c ifuncmain1vispie.c \
		   ifuncmain1staticpie.c \
		   ifuncmain2.c ifuncmain2static.c ifuncdep2.c \
		   ifuncmain2pic.c ifuncmain2picstatic.c ifuncdep2pic.c \
		   ifuncmain3.c ifuncmod3.c \
		   ifuncmain4.c ifuncmain4static.c ifuncmain4picstatic.c \
		   ifuncmain5.c ifuncmain5pic.c ifuncmain5picstatic.c \
		   ifuncmain5pie.c ifuncmain5static.c \
		   ifuncmain5staticpic.c \
		   ifuncdep5.c ifuncdep5pic.c ifuncmod5.c \
		   ifuncmain6pie.c ifuncmod6.c \
		   ifuncmain7.c ifuncmain7pic.c ifuncmain7picstatic.c \
		   ifuncmain7pie.c ifuncmain7static.c \
		   tst-unique1.c tst-unique1mod1.c tst-unique1mod2.c \
		   tst-unique2.c tst-unique2mod1.c tst-unique2mod2.c

CFLAGS-dl-runtime.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-lookup.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-iterate-phdr.c = $(uses-callbacks)

include ../Makeconfig

ifeq ($(unwind-find-fde),yes)
routines += unwind-dw2-fde-glibc
shared-only-routines += unwind-dw2-fde-glibc
endif

before-compile  = $(objpfx)trusted-dirs.h
generated	:= trusted-dirs.h trusted-dirs.st for-renamed/renamed.so
generated-dirs	:= for-renamed

# eglibc: ifeq ($(versioning),yes)
ld-map		= $(common-objpfx)ld.map
# eglibc: endif

ifeq (yes,$(build-shared))
extra-objs	= $(all-rtld-routines:%=%.os) soinit.os sofini.os interp.os
generated	+= librtld.os dl-allobjs.os ld.so ldd
install-others	= $(inst_slibdir)/$(rtld-installed-name)
install-bin-script = ldd
endif

others		= sprof sln
install-bin	= sprof
others-static   = sln
install-rootsbin = sln

ifeq (yes,$(use-ldconfig))
ifeq (yes,$(build-shared))
others-static	+= ldconfig
others		+= ldconfig
install-rootsbin += ldconfig

ldconfig-modules := cache readlib xmalloc xstrdup chroot_canon
extra-objs	+= $(ldconfig-modules:=.o)

# To find xmalloc.c and xstrdup.c
vpath %.c ../locale/programs

endif
endif

tests = tst-tls1 tst-tls2 tst-tls9 tst-leaks1
ifeq (yes,$(have-initfini-array))
tests += tst-array1 tst-array2 tst-array3 tst-array4 tst-array5
endif
ifeq (yes,$(build-static))
tests-static = tst-tls1-static tst-tls2-static tst-stackguard1-static
ifeq (yesyesyes,$(build-static)$(build-shared)$(elf))
tests-static += tst-tls9-static
tst-tls9-static-ENV = \
  EGLIBC_TEST_LD_LIBRARY_PATH=$(objpfx):$(common-objpfx):$(common-objpfx)dlfcn
tst-tls9-static-WRAPPER = $(..)scripts/run-with-env.sh
endif
ifeq (yes,$(have-initfini-array))
tests-static += tst-array1-static tst-array5-static
endif
tests += $(tests-static)
endif
ifeq (yes,$(build-shared))
tests += loadtest restest1 preloadtest loadfail multiload origtest resolvfail \
	 constload1 order vismain noload filter unload \
	 reldep reldep2 reldep3 reldep4 nodelete nodelete2 \
	 nodlopen nodlopen2 neededtest neededtest2 \
	 neededtest3 neededtest4 unload2 lateglobal initfirst global \
	 restest2 next dblload dblunload reldep5 reldep6 reldep7 reldep8 \
	 circleload1 tst-tls3 tst-tls4 tst-tls5 tst-tls6 tst-tls7 tst-tls8 \
	 tst-tls10 tst-tls11 tst-tls12 tst-tls13 tst-tls14 tst-tls15 \
	 tst-tls16 tst-tls17 tst-tls18 tst-tls-dlinfo \
	 tst-align tst-align2 $(tests-execstack-$(have-z-execstack)) \
	 tst-dlmodcount tst-dlopenrpath tst-deep1 \
	 tst-dlmopen1 tst-dlmopen2 tst-dlmopen3 \
	 unload3 unload4 unload5 unload6 unload7 tst-global1 order2 \
	 tst-audit1 tst-audit2 \
	 tst-stackguard1 tst-addr1 tst-thrlock \
	 tst-unique1 tst-unique2
#	 reldep9
test-srcs = tst-pathopt
tests-execstack-yes = tst-execstack tst-execstack-needed tst-execstack-prog
ifeq (x86_64,$(config-machine))
tests += tst-audit3 tst-audit4 tst-audit5 tst-audit6 tst-audit7
endif
endif
ifeq (yesyes,$(have-fpie)$(build-shared))
tests: $(objpfx)tst-pie1.out
endif
tests: $(objpfx)tst-leaks1-mem
tlsmod17a-suffixes = 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19
tlsmod18a-suffixes = 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19
modules-names = testobj1 testobj2 testobj3 testobj4 testobj5 testobj6 \
		testobj1_1 failobj constload2 constload3 unloadmod \
		dep1 dep2 dep3 dep4 vismod1 vismod2 vismod3 \
		nodelmod1 nodelmod2 nodelmod3 nodelmod4 \
		nodel2mod1 nodel2mod2 nodel2mod3 \
		nodlopenmod nodlopenmod2 filtmod1 filtmod2 \
		reldepmod1 reldepmod2 reldepmod3 reldepmod4 nextmod1 nextmod2 \
		reldep4mod1 reldep4mod2 reldep4mod3 reldep4mod4 \
		neededobj1 neededobj2 neededobj3 neededobj4 \
		neededobj5 neededobj6 firstobj globalmod1 \
		unload2mod unload2dep ltglobmod1 ltglobmod2 pathoptobj \
		dblloadmod1 dblloadmod2 dblloadmod3 reldepmod5 reldepmod6 \
	        reldep6mod0 reldep6mod1 reldep6mod2 reldep6mod3 reldep6mod4 \
		reldep7mod1 reldep7mod2 \
		tst-tlsmod1 tst-tlsmod2 tst-tlsmod3 tst-tlsmod4 \
		tst-tlsmod5 tst-tlsmod6 tst-tlsmod7 tst-tlsmod8 \
		tst-tlsmod9 tst-tlsmod10 tst-tlsmod11 tst-tlsmod12 \
		tst-tlsmod13 tst-tlsmod13a tst-tlsmod14a tst-tlsmod14b \
		tst-tlsmod15a tst-tlsmod15b tst-tlsmod16a tst-tlsmod16b \
		$(patsubst %,tst-tlsmod17a%,$(tlsmod17a-suffixes)) \
		tst-tlsmod17b \
		$(patsubst %,tst-tlsmod18a%,$(tlsmod18a-suffixes)) \
		circlemod1 circlemod1a circlemod2 circlemod2a \
		circlemod3 circlemod3a \
		reldep8mod1 reldep8mod2 reldep8mod3 \
		reldep9mod1 reldep9mod2 reldep9mod3 \
		tst-alignmod tst-alignmod2 \
		$(modules-execstack-$(have-z-execstack)) \
		tst-dlopenrpathmod tst-deep1mod1 tst-deep1mod2 tst-deep1mod3 \
		tst-dlmopen1mod tst-auditmod1 \
		unload3mod1 unload3mod2 unload3mod3 unload3mod4 \
		unload4mod1 unload4mod2 unload4mod3 unload4mod4 \
		unload6mod1 unload6mod2 unload6mod3 \
		unload7mod1 unload7mod2 \
		order2mod1 order2mod2 order2mod3 order2mod4 \
		tst-unique1mod1 tst-unique1mod2 \
		tst-unique2mod1 tst-unique2mod2
ifeq (yes,$(have-initfini-array))
modules-names += tst-array2dep tst-array5dep
endif
ifeq (yesyes,$(have-fpie)$(build-shared))
modules-names += tst-piemod1
endif
ifeq (x86_64,$(config-machine))
modules-names += tst-auditmod3a tst-auditmod3b \
		tst-auditmod4a tst-auditmod4b \
		tst-auditmod5a tst-auditmod5b \
		tst-auditmod6a tst-auditmod6b tst-auditmod6c \
		tst-auditmod7a tst-auditmod7b
endif
modules-execstack-yes = tst-execstack-mod
extra-test-objs += $(addsuffix .os,$(strip $(modules-names)))
# We need this variable to be sure the test modules get the right CPPFLAGS.
test-extras += $(modules-names)

# filtmod1.so has a special rule
modules-names-nobuild := filtmod1

ifeq (yes,$(multi-arch))
tests-static += ifuncmain1static ifuncmain1picstatic \
		ifuncmain2static ifuncmain2picstatic \
		ifuncmain4static ifuncmain4picstatic \
		ifuncmain5static ifuncmain5picstatic \
		ifuncmain7static ifuncmain7picstatic

ifeq (yes,$(build-shared))
tests += ifuncmain1 ifuncmain1pic ifuncmain1vis ifuncmain1vispic \
	 ifuncmain1staticpic \
	 ifuncmain2 ifuncmain2pic ifuncmain3 ifuncmain4 \
	 ifuncmain5 ifuncmain5pic ifuncmain5staticpic \
	 ifuncmain7 ifuncmain7pic
ifeq (yes,$(have-fpie))

=== nptl/Makefile ===
# Copyright (C) 2002-2008,2009,2010 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Sub-makefile for NPTL portion of the library.
#
include ../option-groups.mak

subdir	:= nptl

headers := pthread.h semaphore.h bits/semaphore.h

extra-libs := libpthread
extra-libs-others := $(extra-libs)
install-lib-ldscripts := libpthread.so

routines = alloca_cutoff forward libc-lowlevellock libc-cancellation \
	   libc-cleanup
shared-only-routines = forward

libpthread-routines = nptl-init vars events version \
		      pthread_create pthread_exit pthread_detach \
		      pthread_join pthread_tryjoin pthread_timedjoin \
		      pthread_self pthread_equal pthread_yield \
		      pthread_getconcurrency pthread_setconcurrency \
		      pthread_getschedparam pthread_setschedparam \
		      pthread_setschedprio \
		      pthread_attr_init pthread_attr_destroy \
		      pthread_attr_getdetachstate pthread_attr_setdetachstate \
		      pthread_attr_getguardsize pthread_attr_setguardsize \
		      pthread_attr_getschedparam pthread_attr_setschedparam \
		      pthread_attr_getschedpolicy pthread_attr_setschedpolicy \
		      pthread_attr_getinheritsched \
		      pthread_attr_setinheritsched \
		      pthread_attr_getscope pthread_attr_setscope \
		      pthread_attr_getstackaddr pthread_attr_setstackaddr \
		      pthread_attr_getstacksize pthread_attr_setstacksize \
		      pthread_attr_getstack pthread_attr_setstack \
		      pthread_getattr_np \
		      pthread_mutex_init pthread_mutex_destroy \
		      pthread_mutex_lock pthread_mutex_trylock \
		      pthread_mutex_timedlock pthread_mutex_unlock \
		      pthread_mutexattr_init pthread_mutexattr_destroy \
		      pthread_mutexattr_getpshared \
		      pthread_mutexattr_setpshared \
		      pthread_mutexattr_gettype pthread_mutexattr_settype \
		      pthread_rwlock_init pthread_rwlock_destroy \
		      pthread_rwlock_rdlock pthread_rwlock_timedrdlock \
		      pthread_rwlock_wrlock pthread_rwlock_timedwrlock \
		      pthread_rwlock_tryrdlock pthread_rwlock_trywrlock \
		      pthread_rwlock_unlock \
		      pthread_rwlockattr_init pthread_rwlockattr_destroy \
		      pthread_rwlockattr_getpshared \
		      pthread_rwlockattr_setpshared \
		      pthread_rwlockattr_getkind_np \
		      pthread_rwlockattr_setkind_np \
		      pthread_cond_init pthread_cond_destroy \
		      pthread_cond_wait pthread_cond_timedwait \
		      pthread_cond_signal pthread_cond_broadcast \
		      old_pthread_cond_init old_pthread_cond_destroy \
		      old_pthread_cond_wait old_pthread_cond_timedwait \
		      old_pthread_cond_signal old_pthread_cond_broadcast \
		      pthread_condattr_init pthread_condattr_destroy \
		      pthread_condattr_getpshared pthread_condattr_setpshared \
		      pthread_condattr_getclock pthread_condattr_setclock \
		      pthread_spin_init pthread_spin_destroy \
		      pthread_spin_lock pthread_spin_trylock \
		      pthread_spin_unlock \
		      pthread_barrier_init pthread_barrier_destroy \
		      pthread_barrier_wait \
		      pthread_barrierattr_init pthread_barrierattr_destroy \
		      pthread_barrierattr_getpshared \
		      pthread_barrierattr_setpshared \
		      pthread_key_create pthread_key_delete \
		      pthread_getspecific pthread_setspecific \
		      pthread_sigmask pthread_kill pthread_sigqueue \
		      pthread_cancel pthread_testcancel \
		      pthread_setcancelstate pthread_setcanceltype \
		      pthread_once \
		      old_pthread_atfork pthread_atfork \
		      pthread_getcpuclockid \
		      pthread_clock_gettime pthread_clock_settime \
		      sem_init sem_destroy \
		      sem_open sem_close sem_unlink \
		      sem_getvalue \
		      sem_wait sem_trywait sem_timedwait sem_post \
		      cleanup cleanup_defer cleanup_compat \
		      cleanup_defer_compat unwind \
		      pt-longjmp pt-cleanup\
		      cancellation \
		      lowlevellock lowlevelrobustlock \
		      pt-vfork \
		      ptw-write ptw-read ptw-close ptw-fcntl ptw-accept \
		      ptw-connect ptw-recv ptw-recvfrom ptw-recvmsg ptw-send \
		      ptw-sendmsg ptw-sendto ptw-fsync ptw-lseek ptw-llseek \
		      ptw-msync ptw-nanosleep ptw-open ptw-open64 ptw-pause \
		      ptw-pread ptw-pread64 ptw-pwrite ptw-pwrite64 \
		      ptw-tcdrain ptw-wait ptw-waitpid ptw-msgrcv ptw-msgsnd \
		      ptw-sigwait ptw-sigsuspend \
		      pt-raise pt-system \
		      flockfile ftrylockfile funlockfile \
		      sigaction \
		      pt-allocrtsig \
		      pthread_kill_other_threads \
		      pthread_getaffinity pthread_setaffinity \
		      pthread_attr_getaffinity pthread_attr_setaffinity \
		      pthread_mutexattr_getrobust pthread_mutexattr_setrobust \
		      pthread_mutex_consistent \
		      cleanup_routine unwind-forcedunwind \
		      pthread_mutexattr_getprotocol \
		      pthread_mutexattr_setprotocol \
		      pthread_mutexattr_getprioceiling \
		      pthread_mutexattr_setprioceiling tpp \
		      pthread_mutex_getprioceiling \
		      pthread_mutex_setprioceiling \
		      pthread_setname pthread_getname
#		      pthread_setuid pthread_seteuid pthread_setreuid \
#		      pthread_setresuid \
#		      pthread_setgid pthread_setegid pthread_setregid \
#		      pthread_setresgid

libpthread-routines-$(OPTION_EGLIBC_INET) := herrno res 

libpthread-shared-only-routines = version pt-allocrtsig unwind-forcedunwind
libpthread-static-only-routines = pthread_atfork

CFLAGS-pthread_atfork.c = -DNOT_IN_libc

# Since cancellation handling is in large parts handled using exceptions
# we have to compile some files with exception handling enabled, some
# even with asynchronous unwind tables.

# nptl-init.c contains sigcancel_handler().
CFLAGS-nptl-init.c = -fexceptions -fasynchronous-unwind-tables
# The unwind code itself,
CFLAGS-unwind.c = -fexceptions
CFLAGS-unwind-forcedunwind.c = -fexceptions -fasynchronous-unwind-tables

# The following three functions must be async-cancel safe.
CFLAGS-pthread_cancel.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_setcancelstate.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_setcanceltype.c = -fexceptions -fasynchronous-unwind-tables

# These are internal functions which similar functionality as setcancelstate
# and setcanceltype.
CFLAGS-cancellation.c = -fasynchronous-unwind-tables
CFLAGS-libc-cancellation.c = -fasynchronous-unwind-tables

# Calling pthread_exit() must cause the registered cancel handlers to
# be executed.  Therefore exceptions have to be thrown through this
# function.
CFLAGS-pthread_exit.c = -fexceptions

# Among others, __pthread_unwind is forwarded.  This function must handle
# exceptions.
CFLAGS-forward.c = -fexceptions

# The following are cancellation points.  Some of the functions can
# block and therefore temporarily enable asynchronous cancellation.
# Those must be compiled asynchronous unwind tables.
CFLAGS-pthread_testcancel.c = -fexceptions
CFLAGS-pthread_join.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_timedjoin.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_once.c = $(uses-callbacks) -fexceptions \
			-fasynchronous-unwind-tables
CFLAGS-pthread_cond_wait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_cond_timedwait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-sem_wait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-sem_timedwait.c = -fexceptions -fasynchronous-unwind-tables

# These are the function wrappers we have to duplicate here.
CFLAGS-fcntl.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-lockf.c = -fexceptions
CFLAGS-pread.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pread64.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwrite.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwrite64.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-wait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-waitpid.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-sigwait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-msgrcv.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-msgsnd.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-tcdrain.c = -fexceptions -fasynchronous-unwind-tables

CFLAGS-pt-system.c = -fexceptions


tests = tst-typesizes \
	tst-attr1 tst-attr2 tst-attr3 \
	tst-mutex1 tst-mutex2 tst-mutex3 tst-mutex4 tst-mutex5 tst-mutex6 \
	tst-mutex7 tst-mutex8 tst-mutex9 tst-mutex5a tst-mutex7a \
	tst-mutexpi1 tst-mutexpi2 tst-mutexpi3 tst-mutexpi4 tst-mutexpi5 \
	tst-mutexpi5a tst-mutexpi6 tst-mutexpi7 tst-mutexpi7a tst-mutexpi8 \
	tst-mutexpi9 \
	tst-spin1 tst-spin2 tst-spin3 \
	tst-cond1 tst-cond2 tst-cond3 tst-cond4 tst-cond5 tst-cond6 tst-cond7 \
	tst-cond8 tst-cond9 tst-cond10 tst-cond11 tst-cond12 tst-cond13 \
	tst-cond14 tst-cond15 tst-cond16 tst-cond17 tst-cond18 tst-cond19 \
	tst-cond20 tst-cond21 tst-cond22 tst-cond23 \
	tst-robust1 tst-robust2 tst-robust3 tst-robust4 tst-robust5 \
	tst-robust6 tst-robust7 tst-robust8 tst-robust9 \
	tst-robustpi1 tst-robustpi2 tst-robustpi3 tst-robustpi4 tst-robustpi5 \
	tst-robustpi6 tst-robustpi7 tst-robustpi8 tst-robustpi9 \
	tst-rwlock1 tst-rwlock2 tst-rwlock2a tst-rwlock3 tst-rwlock4 \
	tst-rwlock5 tst-rwlock6 tst-rwlock7 tst-rwlock8 tst-rwlock9 \
	tst-rwlock10 tst-rwlock11 tst-rwlock12 tst-rwlock13 tst-rwlock14 \
	tst-once1 tst-once2 tst-once3 tst-once4 \
	tst-key1 tst-key2 tst-key3 tst-key4 \
	tst-sem1 tst-sem2 tst-sem3 tst-sem4 tst-sem5 tst-sem6 tst-sem7 \
	tst-sem8 tst-sem9 tst-sem10 tst-sem11 tst-sem12 tst-sem13 \
	tst-barrier1 tst-barrier2 tst-barrier3 tst-barrier4 \
	tst-align tst-align2 tst-align3 \
	tst-basic1 tst-basic2 tst-basic3 tst-basic4 tst-basic5 tst-basic6 \
	tst-basic7 \
	tst-kill1 tst-kill2 tst-kill3 tst-kill4 tst-kill5 tst-kill6 \
	tst-raise1 \
	tst-join1 tst-join2 tst-join3 tst-join4 tst-join5 tst-join6 \
	tst-detach1 \
	tst-eintr1 tst-eintr2 tst-eintr3 tst-eintr4 tst-eintr5 \
	tst-tsd1 tst-tsd2 tst-tsd3 tst-tsd4 tst-tsd5 tst-tsd6 \
	tst-tls1 tst-tls2 \
	tst-fork1 tst-fork2 tst-fork3 tst-fork4 \
	tst-atfork1 \
	tst-cancel1 tst-cancel2 tst-cancel3 tst-cancel4 tst-cancel5 \
	tst-cancel6 tst-cancel7 tst-cancel8 tst-cancel9 tst-cancel10 \
	tst-cancel11 tst-cancel12 tst-cancel13 tst-cancel14 tst-cancel15 \
	tst-cancel16 tst-cancel17 tst-cancel18 tst-cancel19 tst-cancel20 \
	tst-cancel21 tst-cancel22 tst-cancel23 tst-cancel25 \
	tst-cleanup0 tst-cleanup1 tst-cleanup2 tst-cleanup3 tst-cleanup4 \
	tst-flock1 tst-flock2 \
	tst-signal1 tst-signal2 tst-signal3 tst-signal4 tst-signal5 \
	tst-signal6 tst-signal7 \
	tst-exec2 tst-exec3 tst-exec4 \
	tst-exit1 tst-exit2 tst-exit3 \
	tst-stdio1 tst-stdio2 \
	tst-stack1 tst-stack2 tst-stack3 \
	tst-unload \
	tst-dlsym1 \
	tst-sysconf \
	tst-locale2 \
	tst-umask1 \
	tst-popen1 \
	tst-clock1 \
	tst-context1 \
	tst-sched1 \
	tst-oddstacklimit \
	tst-vfork1 tst-vfork2 tst-vfork1x tst-vfork2x \
	tst-getpid1 tst-getpid2 tst-getpid3 \
	tst-initializers1 $(patsubst %,tst-initializers1-%,c89 gnu89 c99 gnu99)
xtests = tst-setuid1 tst-setuid1-static tst-mutexpp1 tst-mutexpp6 tst-mutexpp10

# This test uses the posix_spawn functions.
tests-$(OPTION_EGLIBC_SPAWN) += tst-exec1

# This test uses the 'backtrace' functions.
tests-$(OPTION_EGLIBC_BACKTRACE) += tst-backtrace1

# This test is written in C++.

=== changelog ===
qt4-x11 (4:4.7.0-0ubuntu4) maverick; urgency=low

  * Fix Lucid -> Maverick upgrade (LP: #652029)
    - libqt4-help replaces libqtcore4 (<< 4:4.7.0)

 -- Alessandro Ghersi <alessandro-ghersi@kubuntu.org>  Sun, 03 Oct 2010 04:14:04 +0200

qt4-x11 (4:4.7.0-0ubuntu3) maverick; urgency=low

  [ Jonathan Riddell ]
  * Add kubuntu_19_gtkstyle_inactive_background.diff recommended by
    upstream, fixes http://bugreports.qt.nokia.com/browse/QTBUG-13792
    'GTK style: Wrong foreground color for selected item when unfocused'
  * Add kubuntu_20_gtkstyle_tabwidget_focus.diff recommended by
    upstream, fixes http://bugreports.qt.nokia.com/browse/QTBUG-14161
    'Tab focus incorrectly drawn with Ubuntu Ambience theme'

  [ Jonathan Thomas ]
  * Add kubuntu_21_fix_phantom_cursor.diff to fix a problem visible in
    several KDE applications (such as Konversation, KPackageKit, and KOrg, to
    name a few) where the cursor would disappear after attempting to paste
    something (http://bugreports.qt.nokia.com/browse/QTBUG-6185)

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 01 Oct 2010 11:59:23 +0100

qt4-x11 (4:4.7.0-0ubuntu2) maverick; urgency=low

  * Add kubuntu_18_fix_qtreeview_regression.diff
    (http://bugreports.qt.nokia.com/browse/QTBUG-13567
     https://bugs.kde.org/show_bug.cgi?id=246997)

 -- Alessandro Ghersi <alessandro-ghersi@kubuntu.org>  Sun, 26 Sep 2010 19:34:58 +0200

qt4-x11 (4:4.7.0-0ubuntu1) maverick; urgency=low

  [ Alessandro Ghersi ]
  * New upstream release
    - Enable 11_build_translations.diff

  [ Jonathan Riddell ]
  * Update kubuntu_15_appmenu.diff from Aurelien Gateau, LP: #643393

 -- Alessandro Ghersi <alessandro-ghersi@kubuntu.org>  Wed, 22 Sep 2010 21:33:24 +0200

qt4-x11 (4:4.7.0~rc1+git20100917-0ubuntu1) maverick; urgency=low

  * New upstream git snapshot
    - Fix FTBS
    - Refresh patches
    - Update install files
    - Update symbol files 

 -- Alessandro Ghersi <alessandro-ghersi@kubuntu.org>  Fri, 17 Sep 2010 08:12:23 +0200

qt4-x11 (4:4.7.0~rc1+git20100916-0ubuntu1) maverick; urgency=low

  * New upstream git snapshot
    - Refresh patches
    - Removed 0001_webkit_self_injection_into_qt_configuration.patch
      fixed by upstream
    - Update install files
    - Update symbol files

 -- Alessandro Ghersi <alessandro-ghersi@kubuntu.org>  Wed, 15 Sep 2010 18:57:09 +0200

qt4-x11 (4:4.7.0~rc1-1ubuntu3) maverick; urgency=low

  * Build QtWebkit so QtAssistant is able to link against it. (LP: #624697)
    We don't actually package QtWebkit here but make qt4-dev-tools depend on
    the binary-compatible libqtwebkit4 package.
    - add kubuntu_17_enable_qtwebkit_for_qtassistant.diff

 -- Felix Geyer <debfx-pkg@fobos.de>  Tue, 14 Sep 2010 15:48:41 +0200

qt4-x11 (4:4.7.0~rc1-1ubuntu2) maverick; urgency=low

  * Update kubuntu_15_appmenu.diff from Aurelien Gateau, fixes memory
    leaks, patch 20100909

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 09 Sep 2010 15:26:42 +0100

qt4-x11 (4:4.7.0~rc1-1ubuntu1) maverick; urgency=low

  [ Felix Geyer ]
  * Merge with Debian git (unreleased), remaining changes:
    - Do not package firebird and ibase packages, remove from debian/rules and
      debian/control
    - libqt4-sql-ibase not recommend for libqt4-sql
    - libqtgui4: suggest, not recommend, qt4-qtconfig
    - Build with -no-phonon
    - Do not package libqt4-phonon
    - Build packages with lzma compression using the dh addon from pkg-kde-tools
    - Rules to remove po dir in clean
    - Add MessagesQt.sh
    - Rules to create Messages.sh link to MessagesQt.sh and rules to create po
      dir and exectue extract-messages.sh in common-install-prehook-impl
    - Rules to remove Messages.sh link
    - Make libqt4-dev depend on libx11-dev
    - In debian/rules Set DEB_HOST_ARCH and
      DEB_HOST_ARCH_OS. Configure with "-arch armv6" option on ARM
    - Disable the Qt OpenVG module
    - Add Kubuntu patches:
      - kubuntu_08_add_missing_bold_style.diff
      - kubuntu_09_use_ft_glyph_embolden_to_fake_bold.diff
      - kubuntu_10_ibus_input_method.diff
      - kubuntu_12_fix_stack_protector.diff
      - kubuntu_15_appmenu.diff
  * Drop kubuntu_16_qx11embed.diff, applied upstream.
  * Adapt kubuntu_15_appmenu.diff to new upstream version.

  [ Jonathan Riddell ]
  * Add kubuntu_16_qt-designer-toplevel-mode-menubar.diff from Aurelien
    Gateau to keep designer working with global menu when in toplevel
    mode

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 03 Sep 2010 13:32:37 +0100

qt4-x11 (4:4.7.0~rc1-1) experimental; urgency=low

  * New upstream release.
  * Remove 0001_add_webkit_qt_config.patch in favor of
    0001_webkit_self_injection_into_qt_configuration.patch.
  * Update debian/control:
    - bump Standards-Version to 3.9.1 (no changes needed).
    - add libopenvg1-mesa-dev build dependency.
    - add libqt4-openvg package.
    - add libqt4-assistant and libqt4-webkit-dbg dummy transitional packages.
  * Update debian/rules:
    - add -openvg configure option.
  * Refresh patches.
  * Update installed files.
  * Update symbols files.

 -- Fathi Boudra <fabo@debian.org>  Thu, 26 Aug 2010 19:54:00 +0300

qt4-x11 (4:4.7.0~beta2-3) experimental; urgency=low

  * Add 0001_add_webkit_qt_config.patch to load modules .pri files.
    Fix the detection of Qt WebKit when shipped standalone.
  * Update debian/control:
    - remove references to Debian in package descriptions
      (derivatives friendly).
    - add libqtwebkit-dev to libqt4-dev package.
    - remove libpulse-dev build dependency. It's used to build Phonon.

 -- Fathi Boudra <fabo@debian.org>  Tue, 20 Jul 2010 16:55:20 +0300

qt4-x11 (4:4.7.0~beta2-2) experimental; urgency=low

  [ Fathi Boudra ]
  * Remove qt_webkit_version.pri file, installed inconditionaly.
    It conflicts with qt_webkit_version.pri shipped in Qt WebKit.

  [ Modestas Vainius ]
  * Make libqt4-dev conflict with libqtwebkit-dev less broad: (<< 2.0~). The


=== debian/changelog ===
xorg (1:7.5+6ubuntu3) maverick; urgency=low

  [ Bryce Harrington ]
  * debian/apport/source_xorg.py:
    + Include .drirc if present
    + Include gconf's /desktop/gnome/peripherals data
    + Quell DkmsStatus no such file error message
  * debian/x11-common.links:
    + Add source package apport hook for xorg-server.  Otherwise,
      apport-collect fails when used on bugs against xorg-server package.

  [ Christopher James Halse Rogers ]
  * Depend on xserver 1.9RC5, bump video and input ABI's

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Mon, 09 Aug 2010 20:34:00 +1000

xorg (1:7.5+6ubuntu2) maverick; urgency=low

  * debian/apport/source_xorg.py:
    + Detect a previous manual install of the nvidia.com drivers, and ask the
      user if they have uninstalled them.
    + Attach the neccesary information for upstreaming nvidia binary bugs.
    + Attach KMS connector information if available.

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Wed, 23 Jun 2010 17:07:53 +1000

xorg (1:7.5+6ubuntu1) maverick; urgency=low

  * Merge from Debian unstable.
  * Depend on xserver 1.8, bump video and input ABI's.

 -- Robert Hooker <sarvatt@ubuntu.com>  Sun, 06 Jun 2010 21:11:01 -0400

xorg (1:7.5+6) unstable; urgency=medium

  * Drop radeonhd from xserver-xorg-video-all.  We switched to kernel
    modesetting for radeon, and that clashes with this driver.
  * Drop v4l from xserver-xorg-video-all.  It depends on the obsolete V4L1
    API, see #569103.
  * Add nouveau to xserver-xorg-video-all on linux x86 and powerpc.  Other
    arches can be added later if needed.
  * x11-common.init: don't include /usr/{s,}bin in PATH, since we only depend
    on $local_fs [lintian].

 -- Julien Cristau <jcristau@debian.org>  Fri, 07 May 2010 13:34:32 +0200

xorg (1:7.5+5ubuntu1) lucid; urgency=low

  * Merge from Debian unstable.

 -- Timo Aaltonen <tjaalton@ubuntu.com>  Thu, 01 Apr 2010 14:27:16 +0300

xorg (1:7.5+5) unstable; urgency=low

  * Fix typo in Xsession.d/50x11-common_determine-startup, closes: #573899.
  * Bump Standards-Version to 3.8.4, no changes needed.

 -- Brice Goglin <bgoglin@debian.org>  Sun, 14 Mar 2010 22:45:09 +0100

xorg (1:7.5+4) unstable; urgency=low

  * Add Xreset and Xreset.d support, closes: #230422.
  * Improve startup speed of Xsession.d scripts by eliminating all unnecessary
    external program calls, thanks Martin Pitt, closes: #570447.
    - In 20x11-common_process-args, cat $OPTIONFILE once into a variable and
      use POSIX variable substitution in all scripts instead of calling grep
      for every single test.
    - Use shell built in "type" instead of external "which" to test for
      programs.
    - 30x11-common_xresources: Swap the order of tests to keep the most
      unlikely (like "~/.Xresources exists") outside, to avoid running the
      other tests (like "xrdb exists") on systems which don't use Xresources.

 -- Brice Goglin <bgoglin@debian.org>  Sun, 14 Mar 2010 11:15:07 +0100

xorg (1:7.5+3ubuntu1) lucid; urgency=low

  [Timo Aaltonen]
  * Merge from debian unstable
  * 50x11-common_determine-startup: Fix a typo in the option name
    (LP: #526532)

  [Bryce Harrington]
  * debian/apport/source_xorg.py: Fix proprietary module detection logic to
    not send all crash bugs to -nvidia.

 -- Bryce Harrington <bryce@ubuntu.com>  Tue, 09 Mar 2010 13:09:08 -0800

xorg (1:7.5+3) unstable; urgency=low

  * Remove the obsolete x11proto-evie-dev from xorg-dev dependencies.

 -- Brice Goglin <bgoglin@debian.org>  Wed, 27 Jan 2010 16:54:23 +0100

xorg (1:7.5+2) unstable; urgency=low

  * Fix typo in debian/scripts/vars.hurd-i386.  Thanks, Samuel Thibault!
  * Add fbdev and vmware video drivers to -all on hurd.  Requested by Samuel
    Thibault.
  * Remove myself from Uploaders
  * Kill xorg-dev dependency on x11proto-fontcache-dev.

 -- Julien Cristau <jcristau@debian.org>  Sat, 23 Jan 2010 03:34:30 +0100

xorg (1:7.5+1ubuntu12) lucid; urgency=low

  * debian/local/Failsafe:
    + udev rules don't have a particular environment set, so we must
      set it up ourselves in order to get $LANG and $LANGUAGE so that
      translations work properly.
      (LP: #528908)
  * debian/apport/source_xorg.py:
    + Only file crash bugs with no traceback against nvidia/fglrx

 -- Bryce Harrington <bryce@ubuntu.com>  Wed, 03 Mar 2010 15:36:28 -0800

xorg (1:7.5+1ubuntu11) lucid; urgency=low

  * Reapply changes from 1:7.5+1ubuntu6, which got clobbered by a later
    upload:
    - Introduce an Xsession.d function has_option() to simplify option
      checking. (LP: #530675)
    - Fix $OPTIONFILE parsing to only match keywords on the beginning of
      lines.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 02 Mar 2010 15:42:08 +0100

xorg (1:7.5+1ubuntu10) lucid; urgency=low

  * debian/apport/source_xorg.py
    + Fix various small problems which caused the hook to fail.
    + Use root_command_outupt to read gdm log files, as they require root to
      read.

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Mon, 01 Mar 2010 18:40:57 +1100

xorg (1:7.5+1ubuntu9) lucid; urgency=low

  [ Bryce Harrington ]
  * debian/x11-common.links:
    + Update links for renamed packages
    + Add apport hook for nvidia-graphics-drivers
    + Add apport hook for -vmmouse (LP: #517664)
    + Remove apport hooks for packages now removed from repository
  * debian/apport/source_xorg.py:
    + Add tagging of release codename
    + Collect gdm logs as root
    + Remove extraneous checking of $DISPLAY
    + Detect vbox, fglrx, and nvidia and file bugs against the respective
      packages instead.
      (LP: #516264)
  
  [ Timo Aaltonen ]
  * debian/x11-common.links: Add xf86-input-evtouch and -wacom.

 -- Bryce Harrington <bryce@ubuntu.com>  Tue, 23 Feb 2010 18:45:03 -0800

xorg (1:7.5+1ubuntu8) lucid; urgency=low

  * debian/scripts/vars.powerpc, debian/scripts/vars.ppc64: Remove the
    dependency on xserver-xorg-video-nouveau. Xserver-xorg-video-nouveau


=== control ===
Source: avahi
Section: net
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Utopia Maintenance Team <pkg-utopia-maintainers@lists.alioth.debian.org>
Uploaders: Sjoerd Simons <sjoerd@debian.org>,
           Sebastian Dröge <slomo@debian.org>,
           Loic Minier <lool@dooz.org>,
           Michael Biebl <biebl@debian.org>
Build-Depends: debhelper (>= 7),
               cdbs (>= 0.4.43),
               pkg-config,
               python-support (>= 0.6),
               libcap-dev (>= 1:2.16) [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !netbsd-i386],
               libgdbm-dev,
               libglib2.0-dev (>= 2.4),
               libgtk2.0-dev (>= 2.14.0),
               libexpat-dev,
               libdaemon-dev (>= 0.11),
               libdbus-1-dev (>= 0.60),
               python-all-dev (>= 2.3.5-11),
               python-gdbm (>= 2.4.3),
               python-dbus,
               python-gtk2 (>= 2.8.6-2),
               libqt3-mt-dev,
               libqt4-dev,
               xmltoman,
               intltool (>= 0.35.0)
Standards-Version: 3.9.0
Vcs-Bzr: https://code.launchpad.net/~ubuntu-desktop/avahi/ubuntu
Homepage: http://avahi.org/

Package: avahi-daemon
Section: net
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser,
         dbus (>= 1.2.16-0ubuntu3),
         lsb-base (>= 3.0-6),
         bind9-host | host
Recommends: libnss-mdns
Suggests: avahi-autoipd
Description: Avahi mDNS/DNS-SD daemon
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains the Avahi Daemon which represents your machine
 on the network and allows other applications to publish and resolve
 mDNS/DNS-SD records.

Package: avahi-dnsconfd
Section: net
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         avahi-daemon,
         lsb-base (>= 3.0-6)
Recommends: resolvconf
Description: Avahi DNS configuration tool
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This tool listens on the network for announced DNS servers and passes
 them to resolvconf so it can use them. This is very useful on autoconfigured
 IPv6 networks.

Package: avahi-autoipd
Section: net
Architecture: i386 ia64 alpha amd64 armeb armel arm hppa lpia m32r m68k mips mipsel powerpc ppc64 s390 s390x sh3 sh3eb sh4 sh4eb sparc
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser
Recommends: dhcp3-client,
            iproute
Conflicts: zeroconf
Description: Avahi IPv4LL network address configuration daemon
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This tool implements IPv4LL, "Dynamic Configuration of IPv4 Link-Local
 Addresses" (IETF RFC3927), a protocol for automatic IP address
 configuration from the link-local 169.254.0.0/16 range without the
 need for a central server. It is primarily intended to be used in
 ad-hoc networks which lack a DHCP server.

Package: python-avahi
Section: python
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         python-gdbm (>= 2.4.3-1),
         libavahi-common-data (>= 0.6.22),
         python-dbus
Provides: ${python:Provides}
Description: Python utility package for Avahi
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains utility modules to talk to Avahi with Python easier.

Package: avahi-utils
Section: net
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         avahi-daemon
Description: Avahi browsing, publishing and discovery utilities
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration.  For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains several utilities that allow you to interact with
 the Avahi daemon, including publish, browsing and discovering services.

Package: avahi-discover
Section: net
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         python-avahi,
         python-dbus,
         python-gtk2 (>= 2.8.6-2),
         python-glade2,
         avahi-daemon
Description: Service discover user interface for avahi
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains a user interface for discovering services.

Package: libavahi-common3
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libavahi-common-data
Description: Avahi common library
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains the Avahi common library, which is a set of common
 functions used by many of Avahis components and client applications.

Package: libavahi-common-data
Section: libs
Architecture: any
Depends: ${misc:Depends}
Description: Avahi common data files
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains common data files for avahi.

Package: libavahi-common-dev
Section: libdevel
Architecture: any
Depends: libavahi-common3 (= ${binary:Version}),
         ${misc:Depends}
Description: Development files for the Avahi common library
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains the development headers for the Avahi common
 library, which is a set of common functions and definitions used by many
 of Avahis components and client applications.

Package: libavahi-common3-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Avahi common library (debian-installer)

Package: libavahi-core7
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Avahi's embeddable mDNS/DNS-SD library
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains the library for Avahi's embeddable mDNS/DNS-SD stack.
 This can be used by embedded applications to integrate mDNS/DNS-SD
 functionality into their applications.
 .
 You should not however use this library for non-embedded applications, you
 should use libavahi-client which interacts with the avahi daemon.

Package: libavahi-core-dev
Section: libdevel
Architecture: any
Depends: libavahi-core7 (= ${binary:Version}),
         ${misc:Depends},
         libavahi-common-dev
Description: Development files for Avahi's embeddable mDNS/DNS-SD library
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains the development files for Avahi's embeddable
 mDNS/DNS-SD stack. This can be used by embedded application developers
 to integrate mDNS/DNS-SD functionality into their applications.
 .
 You should not however use this library for non-embedded applications, you
 shoudl use libavahi-client-dev which interacts with the avahi daemon.

Package: libavahi-core7-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Avahi's embeddable mDNS/DNS-SD library (debian-installer)

Package: libavahi-client3
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Avahi client library
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains the library for Avahi's C API which  allows you
 to integrate mDNS/DNS-SD functionality into your application.

Package: libavahi-client-dev
Section: libdevel
Architecture: any
Depends: libavahi-client3 (= ${binary:Version}),
         ${misc:Depends},
         libavahi-common-dev,
         libdbus-1-dev (>= 0.60)
Description: Development files for the Avahi client library
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This package contains the development headers for Avahi's C API which
 allows you to integrate mDNS/DNS-SD functionality into your application.

Package: libavahi-glib1
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Avahi glib integration library
 Avahi is a fully LGPL framework for Multicast DNS Service Discovery.
 It allows programs to publish and discover services and hosts
 running on a local network with no specific configuration. For
 example you can plug into a network and instantly find printers to
 print to, files to look at and people to talk to.
 .
 This library contains the interface to integrate the Avahi libraries
 into a GLIB main loop application, including GTK+ applications.

Package: libavahi-glib-dev
Section: libdevel
Architecture: any
Depends: libavahi-glib1 (= ${binary:Version}),
         ${misc:Depends},
         libglib2.0-dev,
         libavahi-common-dev
Description: Development headers for the Avahi glib integration library

=== debian/control ===
Source: xorg
Section: x11
Priority: optional
Maintainer: Ubuntu X-SWAT <ubuntu-x@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: David Nusinow <dnusinow@debian.org>, Drew Parsons <dparsons@debian.org>, Brice Goglin <bgoglin@debian.org>
Standards-Version: 3.8.4
Build-Depends: dpkg (>= 1.7.0), po-debconf, debhelper (>= 7.3.15ubuntu3)
Vcs-Git: git://git.debian.org/git/pkg-xorg/debian/xorg
Vcs-Browser: http://git.debian.org/?p=pkg-xorg/debian/xorg.git

Package: x11-common
Architecture: all
Depends: ${misc:Depends}, debianutils (>= 1.13), lsb-base (>= 1.3-9ubuntu2)
Pre-Depends: debconf | debconf-2.0
Conflicts: xfree86-common, xorg-common, xserver-common (<< 7), x-common,
 xserver-xorg (<< 1:7.4~), xserver-xfree86 (<< 1:7.0),
 libxft-dev (<= 2.1.8.2-5),  aee (<= 2.2.15b-1), ascd (<= 0.13.2-3),
 bibview (<= 2.2-8), fvwm1 (<= 1.24r-46), grace (<= 1:5.1.18-1),
 groff (<= 1.18.1.1-7), hfsutils-tcltk (<= 3.2.6-7), login.app (<= 1.2.1-18),
 oneko (<= 1.2.sakura.6-1), procmeter (<= 2.5.1-11), propsel (<= 971130-5.3),
 regexplorer (<= 0.1.6-12), tkseti (<= 3.06-1), wdm (<= 1.28-1),
 wily (<= 0.13.41-6), wmnetselect (<= 0.85-5.5), wmsensors (<= 1.0.4-3.4),
 wmtv (<= 0.6.5-15), xbanner (<= 1.31-23), xcolors (<= 1.5a-2),
 xcolorsel (<= 1.1a-11), xezmlm (<= 1.0.3-11), xfs-xtt (<= 1:1.4.1.xf430-6),
 xgdipc (<= 1.2-0.3), xgmod (<= 3.1-9), xgraph (<= 12.1-3),
 xlogmaster (<= 1.6.0-8), xmailbox (<= 2.5-9), xmem (<= 1.20-19),
 xnecview (<= 1.34-2), xodo (<= 1.2-9.2), xturqstat (<= 2.2.2sarge1),
 xwit (<= 3.4-6), lbxproxy (<< 7.0), proxymngr (<< 7.0), twm (<< 7.0),
 xbase-clients (<< 1:7.0), xdm (<= 1:1.0.1-6), xfs (<< 1:1.0), xfwp (<< 7.0),
 xutils (<< 1:7.0), xvfb (<< 1:1.0), qcam (<= 0.91-11.1), twlog (<= 1.3-4),
 xdmx (<< 1:1.0), bugsx (<= 1.08-8), buici-clock (<= 0.4.5+b1),
 ctwm (<= 3.7-2), emelfm (<= 0.9.2-7), fte-xwindow (<= 0.50.0-1.3),
 fvwm95 (<= 2.0.43ba-23+b1), gerstensaft (<= 0.2-5.1), gipsc (<= 0.4.3-2),
 gradio (<= 1.0.1-6), hanterm-classic (<= 3.1.6.0-4),
 hanterm-xf (<= 1:3.3.1p18-9.2), ibp (<= 0.21-4),
 isdnutils-xtools (<= 1:3.8.2005-12-06-4), ivtools-bin (<= 1.1.3-5),
 kdrill (<= 6.4-2.1), kinput2-canna (<= 3.1-7), kinput2-canna-wnn (<= 3.1-7),
 kinput2-wnn (<= 3.1-7), kterm (<= 6.2.0-45), lm-batmon (<= 0.96-3),
 lwm (<= 1.2.1-1), mctools-lite (<= 970129-16), mgp (<= 1.11b-6),
 olvwm (<= 4.4.3.2p1.4-21), olwm (<= 3.2p1.4-21), pixmap (<= 2.6pl4-14.1),
 plotmtv (<= 1.4.4t-8.1), ppxp-x11 (<= 0.2001080415-14), seyon (<= 2.20c-20),
 skkinput (<= 1:2.06.4-4), tkdesk (<= 2.0-5), videogen (<= 0.32-1),
 vtwm (<= 5.4.7-2), w9wm (<= 0.4.2-4), wmavgload (<= 0.7.0-6.1),
 wmcpu (<= 1.3-4.1), wmdate (<= 0.5-7.1), wmnet (<= 1.05-12),
 wmscope (<= 3.0-9.1), xautolock (<= 1:2.1-6), xbatt (<= 1.2.1-4),
 xbattbar (<= 1.4.2-3.1), xcal (<= 4.1-18.2),
 xcalendar-i18n (<= 4.0.0.i18p1-13.1), xcb (<= 2.4-4), xclip (<= 0.08-5),
 xclips (<= 6.21-6), xdkcal (<= 0.9d-2.1), xdu (<= 3.0-14),
 xengine (<= 1.11-9), xfaces (<= 3.3-25), xfishtank (<= 2.2-23.1),
 xfm (<= 1.4.3-8), xinput (<= 1.2-5.2), xipmsg (<= 0.8088-1.1),
 xlbiff (<< 4.1-4), xli (<= 1.17.0-21), xlockmore (<= 1:5.21-1),
 xlockmore-gl (<= 1:5.21-1), xmeter (<= 1.15-6), xmix (<= 2.1-5),
 xmon (<= 1.5.6-1.3), xpostit (<= 3.3.1-8.2), xprint (<= 1:0.1.0.alpha1-13),
 xrn (<= 9.02-7.1), xsysinfo (<= 1.7-2), xtel (<= 3.3.0-5.4),
 xtoolwait (<= 1.3-6), xtrlock (<= 2.0-11), xview-clients (<= 3.2p1.4-21),
 xviewg (<= 3.2p1.4-21), xviewg-dev (<= 3.2p1.4-21), xvkbd (<= 2.6-2.1),
 xxkb (<= 1.10-2.1), xzoom (<= 0.3-17), pgaccess (<= 1:0.98.8.20030520-2),
 xearth (<= 1.1-10.2), libmotif-dev (<= 2.2.3-1.3),
 motif-clients (<= 2.2.3-1.3), xslideshow (<= 3.1-8.1), xtrkcad (<= 3.1.4-1),
 pmud (<= 0.10-9), xnest (<< 1:1.0), xterm (<< 208-1), xmh (<= 6.8.2.dfsg.1-4),
 beaver (<= 0.2.5-2), lsb-core (<= 3.1-4), yank (<=0.2.1-7.2),
 xpmumon (<= 1.3.0), ivtools-dev (<= 1.1.3-5), ppxp (<= 0.2001080415-14),
 guitar (<= 0.1.4-11), xftp, xext, xpaste, ghostview, xv (<= 3.10a-26),
 xserver-xfree86-dbg, grace6 (<= 5.99.0+final-4), xephem (<= 3.4-5),
 opera (<< 9.10-20060616), hamsoft (<< 0.2.3-1), phototk, tkworld,
 ucbmpeg-play (<< 2.3p-13), netscape-base-4, communicator-smotif-477, epan,
 navigator-smotif-477, stella (<< 2.2-1), xfractint (<< 20.3.01-1), xgobi,
 xpostitplus, xisp, vide (<= 1.21-3), xqbiff (<= 0.75-4)
Replaces: xfree86-common, xorg-common, xserver-common (<< 7), x-common
Description: X Window System (X.Org) infrastructure
 x11-common contains the filesystem infrastructure required for further
 installation of the X Window System in any configuration; it does not
 provide a full installation of clients, servers, libraries, and utilities
 required to run the X Window System.
 .
 A number of terms are used to refer to the X Window System, including "X",
 "X Version 11", "X11", "X11R6", and "X11R7".  The version of X used in
 Debian is derived from the version released by the X.Org Foundation, and
 is thus often also referred to as "X.Org".  All of the preceding quoted
 terms are functionally interchangeable in an Debian system.

Package: xserver-xorg
Architecture: any
Conflicts: xserver-xfree86 (<< 6.8.2.dfsg.1-1), xserver-common (<< 7), x11-common (<< 1:7.3+11)
Replaces: xserver-common (<< 7), x11-common (<< 1:7.3+11)
Depends:
 xserver-xorg-core (>= 2:1.8.99.905),
 xserver-xorg-video-all | xserver-xorg-video-8,
 xserver-xorg-input-all | xserver-xorg-input-11,
 xserver-xorg-input-evdev [alpha amd64 arm armeb armel hppa i386 ia64 lpia m32r m68k mips mipsel powerpc sparc],
 hal (>= 0.5.12~git20090406) [kfreebsd-any],
 ${shlibs:Depends},
 ${misc:Depends},
 xkb-data (>= 1.4),
 x11-xkb-utils,
 console-setup
Recommends:
 libgl1-mesa-dri,
Description: the X.Org X server
 This package depends on the full suite of the server and drivers for the
 X.Org X server.  It does not provide the actual server itself.

Package: xserver-xorg-video-all
Architecture: any
Depends:
 ${F:XServer-Xorg-Video-Depends},
 ${misc:Depends},
 x11-common,
Replaces: xserver-xorg-driver-all
Conflicts: xserver-xorg-driver-all
Description: the X.Org X server -- output driver metapackage
 This package depends on the full suite of output drivers for the X.Org X server
 (Xorg).  It does not provide any drivers itself, and may be removed if you wish
 to only have certain drivers installed.

Package: xserver-xorg-input-all
Architecture: any
Depends:
 ${F:XServer-Xorg-Input-Depends},
 ${misc:Depends},
 x11-common,
Description: the X.Org X server -- input driver metapackage
 This package depends on the full suite of input drivers for the X.Org X server
 (Xorg).  It does not provide any drivers itself, and may be removed if you wish
 to only have certain drivers installed.

Package: xorg
Architecture: any
Depends:
 xserver-xorg,
 libgl1-mesa-glx | libgl1,
 libgl1-mesa-dri,
 libglu1-mesa,
 xfonts-base (>= 1:1.0.0-1),
 xfonts-100dpi (>= 1:1.0.0-1),
 xfonts-75dpi (>= 1:1.0.0-1),
 x11-apps,
 x11-session-utils,
 x11-utils,
 x11-xfs-utils,
 x11-xkb-utils,
 x11-xserver-utils,
 xauth,
 xinit,
 xfonts-utils,
 xkb-data,
 xorg-docs-core,
 xterm | x-terminal-emulator,
 ${misc:Depends},
 x11-common,
 xinput,
Recommends:
 xfonts-scalable (>= 1:1.0.0-1),
Provides: x-window-system, x-window-system-core
Suggests: xorg-docs
Description: X.Org X Window System
 This metapackage provides the components for a standalone
 workstation running the X Window System.  It provides the X libraries, an X
 server, a set of fonts, and a group of basic X clients and utilities.
 .
 Higher level metapackages, such as those for desktop environments, can
 depend on this package and simplify their dependencies.
 .
 It should be noted that a package providing x-window-manager should also
 be installed to ensure a comfortable X experience.

Package: xorg-dev
Architecture: all
Depends:
 libdmx-dev,
 libfontenc-dev,
 libfs-dev,
 libice-dev,
 libsm-dev,
 libx11-dev,
 libxau-dev,
 libxaw7-dev,
 libxcomposite-dev,
 libxcursor-dev,
 libxdamage-dev,
 libxdmcp-dev,
 libxext-dev,
 libxfixes-dev,
 libxfont-dev,
 libxft-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbfile-dev,
 libxmu-dev,
 libxmuu-dev,
 libxpm-dev,
 libxrandr-dev,
 libxrender-dev,
 libxres-dev,
 libxss-dev,
 libxt-dev,
 libxtst-dev,
 libxv-dev,
 libxvmc-dev,
 libxxf86dga-dev,
 libxxf86vm-dev,
 x11proto-bigreqs-dev,
 x11proto-composite-dev,
 x11proto-core-dev,
 x11proto-damage-dev,
 x11proto-dmx-dev,
 x11proto-fixes-dev,
 x11proto-fonts-dev,
 x11proto-gl-dev,
 x11proto-input-dev,
 x11proto-kb-dev,
 x11proto-randr-dev,
 x11proto-record-dev,
 x11proto-render-dev,
 x11proto-resource-dev,
 x11proto-scrnsaver-dev,
 x11proto-video-dev,
 x11proto-xcmisc-dev,
 x11proto-xext-dev,
 x11proto-xf86bigfont-dev,
 x11proto-xf86dga-dev,
 x11proto-xf86dri-dev,
 x11proto-xf86vidmode-dev,
 x11proto-xinerama-dev,
 xserver-xorg-dev,
 xtrans-dev,
 ${misc:Depends},
 x11-common,
Description: the X.Org X Window System development libraries
 This metapackage provides the development libraries for the X.Org X Window
 System.
 .
 X Window System design documentation, manual pages, library reference
 works, static versions of the shared libraries, and C header files are
 supplied by the packages depended on by this metapackage.
 .
 Note that this is a convenience package for users and is not a package for
 Debian developers to have their package depend on.

Package: xlibmesa-gl
Section: libs
Architecture: all
Depends:
 libgl1-mesa-glx,
 ${misc:Depends},
 x11-common,
Description: transitional package for Debian etch
 This package is provided to smooth upgrades from Debian 3.1 ("sarge") to
 Debian etch. It may be safely removed from your system.

Package: xlibmesa-gl-dev
Section: libdevel
Architecture: all
Depends:
 libgl1-mesa-dev,
 ${misc:Depends},
 x11-common,
Description: transitional package for Debian etch
 This package is provided to smooth upgrades from Debian 3.1 ("sarge") to
 Debian etch. It may be safely removed from your system.

Package: xlibmesa-glu
Section: libdevel
Architecture: all
Depends:
 libglu1-mesa,
 ${misc:Depends},
 x11-common,
Description: transitional package for Debian etch
 This package is provided to smooth upgrades from Debian 3.1 ("sarge") to
 Debian etch. It may be safely removed from your system.

Package: libglu1-xorg
Section: libs
Architecture: all
Depends:
 libglu1-mesa,
 ${misc:Depends},
 x11-common,
Description: transitional package for Debian etch
 This package is provided to smooth upgrades from Debian 3.1 ("sarge") to
 Debian etch. It may be safely removed from your system.
 
Package: libglu1-xorg-dev
Section: libdevel
Architecture: all
Depends:
 libglu1-mesa-dev,
 ${misc:Depends},
 x11-common,
Description: transitional package for Debian etch
 This package is provided to smooth upgrades from Debian 3.1 ("sarge") to
 Debian etch. It may be safely removed from your system.

Package: xbase-clients
Section: x11
Architecture: all
Depends:
 x11-apps,
 x11-session-utils,
 x11-utils,
 x11-xfs-utils,
 x11-xkb-utils,
 x11-xserver-utils,
 xauth,
 xinit,
 ${misc:Depends},
 x11-common,
Description: miscellaneous X clients - metapackage
 An X client is a program that interfaces with an X server (almost always via
 the X libraries), and thus with some input and output hardware like a
 graphics card, monitor, keyboard, and pointing device (such as a mouse).
 .
 This package provides a miscellaneous assortment of several dozen X clients
 that ship with the X Window System.
 .
 This package is provided for transition from earlier Debian releases, the
 programs formerly in xutils and xbase-clients having been split out in smaller
 packages.

Package: xutils
Section: x11
Architecture: all
Depends:
 x11-xfs-utils,
 x11-utils,
 x11-xserver-utils,
 x11-session-utils,
 xfonts-utils,
 ${misc:Depends},
 x11-common,
Description: X Window System utility programs metapackage
 xutils provides a set of utility programs shipped with the X Window System.
 Many of these programs are useful even on a system that does not have any X

=== debian/rules ===
#!/usr/bin/make -f

export DH_COMPAT=4

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Lowest version with fully ABI compatible libraries
SHLIB_VERSION=20080808

ROOT=/
ROOTL=
SUFFIX=32
SUFFIXL=32

# Set Arch specific variables
# On amd64 some package compile 32bit debs directly.
# Skip converting them and Depend on them instead.
ifeq (amd64,$(DEB_HOST_ARCH))
  lib_depends = libc6-i386 (>= 2.3.6-2), lib32z1, lib32stdc++6, lib32asound2, lib32bz2-1.0, lib32ncurses5, lib32v4l-0
  FILTER = zlib1g libc6 libgcc1 libasound2 libbz2-1.0 libstdc++6 libncurses5 libv4l-0
  EXTRA_INSTALL =
else
  lib_depends = 
  FILTER = libgcc1
  EXTRA_INSTALL = install-ia32-libs-dev install-lib32gcc1
  LIBGCC_VERSION := $(shell dpkg -I pkgs/libgcc1_*deb | awk '/Version/ {print $$2; exit}')
  LIBGCC_VER1 := $(shell echo $(LIBGCC_VERSION) | sed 's/+b[0-9]*//')
  LIBGCC_VER2 := +ia32.libs.$(shell dpkg-parsechangelog  | grep ^Version | awk '{print $$2}')
  LIBGCC_VER3 := $(shell echo $(LIBGCC_VERSION) | sed -n 's/.*\(+b[0-9]*\)/\1/p')
  LIB32GCC_VERSION := $(LIBGCC_VER1)$(LIBGCC_VER2)$(LIBGCC_VER3)
endif

build:
#	./fetch-and-build

clean:
	dh_testdir
	dh_testroot
	dh_clean

install-prefix:
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

######################################################################
# common variables
######################################################################

MAKE := $(MAKE) -f debian/rules
DEBS_ALL := $(shell cd pkgs; ls *.deb | cut -d"_" -f1)

DEBS_ia32-libs     := $(filter-out %-dev $(FILTER),$(DEBS_ALL))
DEBS_ia32-libs-dev := $(filter %-dev,$(DEBS_ALL))
DEBS_lib32gcc1     := libgcc1 gcc-4.5-base

EXTRACT_ia32-libs     := $(addprefix extract-,$(DEBS_ia32-libs))
EXTRACT_ia32-libs-dev := $(addprefix extract-,$(DEBS_ia32-libs-dev))
EXTRACT_lib32gcc1     := $(addprefix extract-,$(DEBS_lib32gcc1))

######################################################################
# common helper
######################################################################
# All helpers expect DEST to be set to debian/<pkg>

.PRECIOUS: %/DEBIAN/Manifest
%/DEBIAN/Manifest:
	mkdir -p $(DEST)/DEBIAN/
	echo "# packages used in the creation of $(notdir $(DEST))" \
	     > $(DEST)/DEBIAN/Manifest
	echo >> $(DEST)/DEBIAN/Manifest

extract-%: $(DEST)/DEBIAN/Manifest
	cd pkgs && echo $*_*.deb >> ../$(DEST)/DEBIAN/Manifest
	dpkg-deb -x pkgs/$*_*.deb $(DEST)/t

	# change shlibs information
	# libX Y * ---> libX Y <DEST> (>= SHLIB_VERSION)
	dpkg-deb -e pkgs/$*_*.deb $(DEST)/t/DEBIAN
	if [ -f $(DEST)/t/DEBIAN/shlibs ]; then \
	  grep -v "^udeb:" < $(DEST)/t/DEBIAN/shlibs \
	  | sed "s/^\(\S*\s*\S*\).*/\1 $(notdir $(DEST)) (>= $(SHLIB_VERSION))/" >>$(DEST)/DEBIAN/shlibs; \
	fi
	rm -r $(DEST)/t/DEBIAN

move-libs:
	# Move libraries to new places
	[ ! -d $(DEST)/t/lib ] \
	|| ( mkdir -p $(DEST)$(ROOT) \
	   && mv $(DEST)/t/lib $(DEST)$(ROOT)lib$(SUFFIX) )
	[ ! -d $(DEST)/t/usr/lib ] \
	|| ( mkdir -p $(DEST)$(ROOT)usr \
	   && mv $(DEST)/t/usr/lib $(DEST)$(ROOT)usr/lib$(SUFFIX) )

fix-links:
	# change links in $(DEST)$(ROOT) to new names
	for link in $$(find $(DEST)$(ROOT) -type l); do		\
	  dest=$$(readlink $$link);				\
	  case "$$dest" in					\
	    /etc*) ;;						\
	    /usr/lib/locale*) ;;				\
	    /*) rm -f $$link;					\
	        ln -s $$(echo $$dest | sed -e 's,^/,$(ROOT),' -e 's,/lib/,/lib$(SUFFIX)/,') $$link;	\
	        ;;						\
	  esac;							\
	done

######################################################################
# ia32-libs
######################################################################
install-ia32-libs: DEST=debian/ia32-libs
install-ia32-libs: install-prefix
	# Extract all debs
	$(MAKE) DEST=$(DEST) $(EXTRACT_ia32-libs)

	# Move libraries to new places
	$(MAKE) DEST=$(DEST) move-libs

ifeq (ia64,$(DEB_HOST_ARCH))
	# Make ldd work for 32-bit and 64-bit binaries.
	[ -x $(DEST)/t/usr/bin/ldd ]
	RTLDLIST="/lib/ld-linux-ia64.so.2 /lib/ld-linux.so.2" ; \
	sed -i "s%RTLDLIST=.*%RTLDLIST=\"$$RTLDLIST\"%" $(DEST)/t/usr/bin/ldd
	sed -i 's%verify_out=`$${rtld} --verify "$$file"`%verify_out=`$${rtld} --verify "$$file" 2>\&1`%' $(DEST)/t/usr/bin/ldd

	# Move ldd into place
	mkdir -p $(DEST)/usr/bin
	mv $(DEST)/t/usr/bin/ldd $(DEST)/usr/bin
	# removed in glibc 2.5
	#mv $(DEST)/t/usr/bin/lddlibc4 $(DEST)/usr/bin
	chmod u=rwx,go=rx $(DEST)/usr/bin/ldd

	# Link the ld.so into place
	mkdir -p $(DEST)/lib/
	ln -s $(ROOT)lib$(SUFFIX)/ld-linux.so.2 $(DEST)/lib/ld-linux.so.2

	# Add /lib32 and /usr/lib32 to ld search path
	mkdir -p $(DEST)/etc/ld.so.conf.d
	cp -p debian/ia32-libs.conf $(DEST)/etc/ld.so.conf.d/

ifneq (/,$(ROOT))
	# Move uname into place
	mkdir -p $(DEST)$(ROOT)bin
	mv $(DEST)/t/bin/uname $(DEST)$(ROOT)bin

	# Create /usr/lib32 link for gcc
	ln -s $(ROOT)usr/lib$(SUFFIX) $(DEST)/usr/lib32
endif
endif

	# Add locale symlink
	ln -s /usr/lib/locale $(DEST)$(ROOT)usr/lib$(SUFFIX)/locale

	# Add a ".so" symlink to each shared lib lacking one
	for where in usr/lib lib ; do \
		echo "* doing /$${where}$(SUFFIX)" ; \
		cd $(CURDIR)/$(DEST)$(ROOT)$${where}$(SUFFIX)/ && \
		for lib in $$(find . -maxdepth 1 -type f -name \*.so\* | sort) ; do \
			SO=$$(echo $$lib | sed -e 's/\(\.so\)\.[.0-9]*$$/\1/') ; \
			if [ "Z$$SO" != "Z$$lib" ] ; then \
				if [ ! -e $$SO ] ; then \
					SSO=$$(find . -lname $$(basename $$lib) | head -1) ; \
					if [ "Z$$SSO" != Z ] ; then \
						ln -vs $$SSO $$SO ; \
					else \
						ln -vs $$lib $$SO ; \
					fi \
				fi \
			fi \
		done \
	done

	# More symlinks, not covered by the code above
	cd $(DEST)$(ROOT)/usr/lib$(SUFFIX)/ && \
	ln -s /lib32/libpng12.so.0 libpng.so && \
	ln -s /lib32/libpng12.so.0 libpng12.so && \
	ln -s liblber-2.4.so liblber.so && \
	ln -s libldap_r-2.4.so libldap_r.so

	cd $(DEST)$(ROOT)/lib$(SUFFIX)/ && \
	ln -s libusb-0.1.so libusb.so

	# Drop the libstdc++.so symlink, it's provided by g++-4.4-multilib (LP: #360870)
	cd $(DEST)$(ROOT)/usr/lib$(SUFFIX)/ && \
	rm -f libstdc++.so

	# Provide proper links for gtk modules (LP: #369498)
	dh_link -pia32-libs /usr/lib32/gtk-2.0/2.10.0 /usr/lib/gtk-2.0/2.10.0/i486-pc-linux-gnu
	dh_link -pia32-libs /usr/lib32/gtk-2.0/       /usr/lib/gtk-2.0/i486-pc-linux-gnu
	dh_link -pia32-libs /usr/lib32/gtk-2.0/2.10.0 /usr/lib/gtk-2.0/2.10.0/i686-pc-linux-gnu
	dh_link -pia32-libs /usr/lib32/gtk-2.0/       /usr/lib/gtk-2.0/i686-pc-linux-gnu

	# Remove atk-bridge module (LP: #369498)
	rm $(DEST)$(ROOT)usr/lib32/gtk-2.0/modules/libatk-bridge.so

	# Provide proper links for libglib2 (LP: #369498)
	dh_link -pia32-libs /usr/lib32/gio/modules /usr/lib/gio/modules/i486-pc-linux-gnu
	dh_link -pia32-libs /usr/lib32/gio/modules /usr/lib/gio/modules/i686-pc-linux-gnu

	# Provide proper links for libGL (LP: #513554)
	dh_link -pia32-libs /usr/lib32/mesa/libGL.so.1 /usr/lib32/libGL.so

	# verify and install pango.modules
	PANGOMODS=$$(dpkg-deb -c pkgs/libpango*i386.deb | grep modules/pango | cut -d. -f2- | sed -e 's,/lib/,/lib32/,'); \
	for i in $$(grep -v ^'#' debian/pango.modules | cut -d" " -f1 | sort -u); \
	do \
		if ! echo "$$PANGOMODS" | grep -q ^$$i; then \
			echo "ERROR: Pango module $$i not listed in libpango package." >&2 ; \
			echo "Please update debian/pango.modules" >&2; \
			exit 1; \
		fi; \
	done
	install -m644 debian/pango.modules debian/ia32-libs/usr/lib32/pango/1.6.0/module-files.d/libpango1.0-0.modules

	# Remove unwanted directories and pt_chown
	rm -rf $(DEST)/t
	rm -f $(DEST)$(ROOT)usr/lib$(SUFFIX)/pt_chown

	# Add doc dir, lintian overrides and Manifest
	mkdir -p $(DEST)/usr/share/doc/ia32-libs
	mkdir -p $(DEST)/usr/share/lintian/overrides
	cp debian/ia32-libs.overrides $(DEST)/usr/share/lintian/overrides/ia32-libs
	mv $(DEST)/DEBIAN/Manifest $(DEST)/usr/share/doc/ia32-libs/Manifest.ia32-libs

	# Fix symlinks.
	$(MAKE) DEST=$(DEST) fix-links


######################################################################
# ia32-libs-dev
######################################################################
install-ia32-libs-dev: DEST=debian/ia32-libs-dev

=== rules ===
#! /usr/bin/make -f
# Based on the sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# Ensure the build aborts when there are still references to undefined
# symbols.
LDFLAGS += -Wl,-z,defs

# Make the linker work a bit harder so dynamic loading can be done faster
LDFLAGS += -Wl,-O1

# Make the linker only include actual dependencies on libraries, rather than
# for all libraries specified in the link line.
LDFLAGS += -Wl,--as-needed

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

upstreamversion=$(shell dpkg-parsechangelog | grep Version | head -1 | sed -e 's/Version: //g' -e 's/-[A-Za-z0-9\.]*$$//g')

# Only build the runtime packages? Note: be sure to keep this consistent
# with the packages listed in debian/control.
oldlibs_build=0

# These values must match their configure.in counterparts
gsf_version_major=1
gsf_version_minor=14

# This goes into the package names; make sure the debian/* files match
so_version_major=$(shell expr $(gsf_version_major) '*' 100 '+' $(gsf_version_minor))

# Package names
p_libgsf=libgsf-1-$(so_version_major)
p_libgsf_gnome=libgsf-gnome-1-$(so_version_major)
p_libgsf_common=libgsf-1-common
p_libgsf_bin=libgsf-bin
p_libgsf_dev=libgsf-1-dev
p_libgsf_gnome_dev=libgsf-gnome-1-dev
p_libgsf_dbg=libgsf-1-$(so_version_major)-dbg
p_libgsf_gnome_dbg=libgsf-gnome-1-$(so_version_major)-dbg

# Build up the options for "./configure"
confflags :=	-v

# FHS locations
confflags +=	--prefix=/usr \
		--sysconfdir=/etc \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--with-html-dir=\$${prefix}/share/doc/$(p_libgsf_dev)/html

# Compiler, language dialect
confflags +=	--enable-compile-warnings=maximum

# Features
confflags +=	--with-bz2 --enable-gtk-doc --without-python \
		--with-gio --with-gnome-vfs

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build $(DEB_HOST_GNU_TYPE)
else
	confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif


source-updates:
	# Update files/links generated by autotools
	env srcdir=`pwd` NOCONFIGURE=1 sh autogen.sh
	# Replace links by copies of their targets
	for file in `find -type l` ; do \
		tf=`tempfile` && \
		install -p $$file $$tf && \
		rm -f $$file && \
		install -p $$tf $$file && \
		rm -f $$tf ; \
	done
	rm -rf autom4te.cache

configure: config-stamp
config-stamp:
	dh_testdir
	dh_prep

	rm -rf build && mkdir build
	# With current libtool (1.5.24-1), LDFLAGS ends up on the actual
	# link line after some "-l" parameters. This is unfortunate, as it
	# means that passing "-Wl,--as-needed" through LDFLAGS will not drop
	# references to all unneeded libraries.
	#
	# To work around this, we pass LDFLAGS through CC (which is also
	# used for the link rules). The price we pay is some "linker input
	# file unused because linking not done" warnings.
	cd build && env "CC=$(CC) $(LDFLAGS)" "CFLAGS=$(CFLAGS)" ../configure $(confflags)

	touch config-stamp

build: build-stamp
build-stamp:  config-stamp
	dh_testdir
	cd po; intltool-update -p

	$(MAKE) -C build

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	if test -d build && test -f build/Makefile ; then \
		$(MAKE) -C build distclean; \
	fi
	rm -rf build

	-find -type f -name 'Makefile.am' | sed -e 's/\.am$$//' | xargs rm -f

	# Update config.{sub,guess} from autotools-dev, if possible.
	-for f in config.sub config.guess ; do \
		if test -r /usr/share/misc/$$f ; then \
			OLDDATE=`./$$f -t | tr -d -` ; \
			NEWDATE=`/usr/share/misc/$$f -t | tr -d -` ; \
			if [ $$OLDDATE -lt $$NEWDATE ] ; then \
				echo "GNU config automated update of $$f (replacing $$OLDDATE with $$NEWDATE)" 1>&2 ; \
				cp -f /usr/share/misc/$$f $$f ; \
			fi; \
		fi; \
	done

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) -C build \
		GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1 \
		DESTDIR=$(CURDIR)/debian/tmp \
		install

	@if ! test -r $(CURDIR)/debian/tmp/usr/lib/libgsf-gnome-1.so ; then \
		echo "" ; \
		echo "libgsf-gnome-1 didn't get installed properly" ; \
		echo "Perhaps ltmain.sh needs to be regenerated using a libtool package patched" ; \
		echo "with the \"inst-prefix\" patch?" ; \
		exit 1; \
	fi

	rm -f $(CURDIR)/debian/tmp/usr/lib/libgsf-*.la

	mkdir -p $(CURDIR)/debian/tmp/usr/lib/debug
	for l in `find $(CURDIR)/debian/tmp/usr/lib -name '*.so*'`; do \
		cp -vdf $$l $(CURDIR)/debian/tmp/usr/lib/debug ; \
	done

ifeq ($(oldlibs_build),1)
	# Delete files and directories that belong to packages we don't build
	cat debian/$(p_libgsf_common).install debian/$(p_libgsf_bin).install debian/$(p_libgsf_dev).install debian/$(p_libgsf_gnome_dev).install debian/$(p_libgsf_dbg).install debian/$(p_libgsf_gnome_dbg).install | while read pattern ; do \
		(cd debian/tmp && rm -vrf $$pattern) ; \
	done
	# Basically all remaining files and directories should belong to a
	# package.
else
	# Building not just runtime packages. Basically all installed files
	# and directories should belong to a package.
endif

	dh_install --sourcedir=debian/tmp --fail-missing -Xindex.sgml

# This single target is used to build all the packages, all at once, or
# one at a time. So keep in mind: any options passed to commands here will
# affect _all_ packages. Anything that should only affect one package
# should be put in another target (such as the install target) or be put
# into conditional constructs.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
ifeq ($(DH_OPTIONS),-s)
	# The -dbg packages don't have separate documentation; link to the
	# corresponding runtime packages' documentation.
	rm -rvf $(CURDIR)/debian/$(p_libgsf_dbg)/usr/share/doc/$(p_libgsf_dbg)
	rm -rvf $(CURDIR)/debian/$(p_libgsf_gnome_dbg)/usr/share/doc/$(p_libgsf_gnome_dbg)

	# Unfortunately, "-s" overrides "-p" for dh_link messes things up.
	env -u DH_OPTIONS dh_link -p$(p_libgsf_dbg) /usr/share/doc/$(p_libgsf)/ /usr/share/doc/$(p_libgsf_dbg)
	env -u DH_OPTIONS dh_link -p$(p_libgsf_gnome_dbg) /usr/share/doc/$(p_libgsf)/ /usr/share/doc/$(p_libgsf_gnome_dbg)
	# Make the documentation accessible through devhelp.
	env -u DH_OPTIONS dh_link -p$(p_libgsf_dev) /usr/share/doc/$(p_libgsf_dev)/html/gsf/ /usr/share/gtk-doc/html/gsf
endif
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installman
#	dh_installcron
#	dh_installinfo
#	dh_undocumented
	dh_gconf
#	dh_link
	dh_buildinfo
	dh_compress
#	dh_perl
#	dh_python
ifeq ($(DH_OPTIONS),-s)
	dh_strip -s -v

	# Unfortunately, "-s" overrides "-p" for dh_makeshlibs and by acting
	# on all architecture-dependent packages we would get wrong shlibs
	# here, so we need to undo the "-s".
	env -u DH_OPTIONS dh_makeshlibs -p$(p_libgsf) -V '$(p_libgsf) (>= $(upstreamversion))'
	env -u DH_OPTIONS dh_makeshlibs -p$(p_libgsf_gnome) -V '$(p_libgsf_gnome) (>= $(upstreamversion))'

	dh_shlibdeps -s -l debian/$(p_libgsf)/usr/lib/ -L $(p_libgsf) \
		-l debian/$(p_libgsf_gnome)/usr/lib/ -L $(p_libgsf_gnome)
endif
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
binary-indep: build install
	 $(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build install
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

=== watch ===
version=3
http://alioth.debian.org/frs/download.php/3258/sane-backends-([\d\.]+).tar.gz
